Bug 1074147 - Review Request: apt-cacher-ng - Caching proxy for package files from Debian
Summary: Review Request: apt-cacher-ng - Caching proxy for package files from Debian
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Christopher Meng
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 964317 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-03-08 07:53 UTC by Kenjiro Nakayama
Modified: 2014-05-01 22:28 UTC (History)
4 users (show)

Fixed In Version: apt-cacher-ng-0.7.25-3.fc20
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-05-01 22:28:05 UTC
i: fedora-review+
petersen: fedora-cvs+


Attachments (Terms of Use)

Description Kenjiro Nakayama 2014-03-08 07:53:54 UTC
Spec URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng.spec
SRPM URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng-0.7.11-3.fc20.src.rpm
Description: caching proxy server for debian's apt repositories.
Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6603361

Fedora Account System Username: kenjiro

This is my first package, so I need a sponsor.

Comment 1 Kenjiro Nakayama 2014-03-08 07:54:14 UTC
*** Bug 964317 has been marked as a duplicate of this bug. ***

Comment 2 Warren Togami 2014-03-11 01:35:36 UTC
I am willing to sponsor Kenjiro after he demonstrates cleaning up these packages such that they pass Fedora package review.  I would appreciate if others complete the package review.

Comment 3 Christopher Meng 2014-03-11 01:46:07 UTC
(In reply to Warren Togami from comment #2)
> I am willing to sponsor Kenjiro after he demonstrates cleaning up these
> packages such that they pass Fedora package review.  I would appreciate if
> others complete the package review.

Good to see that, thanks a lot. I will review this one later.

Comment 4 Christopher Meng 2014-03-13 09:23:15 UTC
1. URL:            http://packages.ubuntu.com/raring/apt-cacher-ng

Hmm...Just a joke here, Ubuntu steals nearly everything from Debian, thus this package is not from Ubuntu, actually it has its own address:

http://www.unix-ag.uni-kl.de/~bloch/acng/

2. Its latest version is 0.7.25 via PTS:

http://packages.qa.debian.org/a/apt-cacher-ng.html

3. %description is shorter than %summary... You can do better...

4. rm -rf $RPM_BUILD_ROOT is not needed.

5. install with -p to preserve the timestamp.

6. gzip doc/man/*.8
cp   doc/man/*.8.gz $RPM_BUILD_ROOT%{_mandir}/man8/

You shouldn't gzip the manpages, RPM will do that automatically for you.

7. Will you support EPEL5? If not remove everything related to it including conditional lines.

8. Cron jobs packaging guideline:

https://fedoraproject.org/wiki/Packaging:CronFiles

Comment 5 Kenjiro Nakayama 2014-03-14 00:15:21 UTC
(In reply to Christopher Meng from comment #4)

Thanks.

I updated.

Updated Spec URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng.spec
Updated SRPM URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng-0.7.25-3.fc20.src.rpm
koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6631347

> 1. URL:            http://packages.ubuntu.com/raring/apt-cacher-ng

Updated.

> 2. Its latest version is 0.7.25 via PTS:

Updated.

> 3. %description is shorter than %summary... You can do better...

Updated both summary and description.

> 4. rm -rf $RPM_BUILD_ROOT is not needed.

Updated.

> 5. install with -p to preserve the timestamp.

Updated.

> 6. gzip doc/man/*.8
> cp   doc/man/*.8.gz $RPM_BUILD_ROOT%{_mandir}/man8/

Updated.

> 7. Will you support EPEL5? If not remove everything related to it including conditional lines.

Updated. (Removed, It's not neecessary to support EPEL5.)

> 8. Cron jobs packaging guideline:
> 
> https://fedoraproject.org/wiki/Packaging:CronFiles

Update and also updated logrotate under the guideline.

https://fedoraproject.org/wiki/User:Johannbg/Packaging/LogFiles#Logrotate_file

Comment 6 Christopher Meng 2014-03-14 00:34:29 UTC
1. Sources should not contain any local server name like .de, you can replace it with .jp, it still works ;)

Debian reources can be reached from:

http://ftp.debian.org/debian/pool/main/a/apt-cacher-ng/

An example:

http://ftp.debian.org/debian/pool/main/a/apt-cacher-ng/apt-cacher-ng_%{version}.orig.tar.xz
http://ftp.debian.org/debian/pool/main/a/apt-cacher-ng/apt-cacher-ng_%{version}-1.debian.tar.xz

2. mkdir -p $RPM_BUILD_ROOT%{_sbindir}/
cp build/apt-cacher-ng $RPM_BUILD_ROOT%{_sbindir}/

In order to ensure that the permissions are set correctly, for binaries you should use install with -m option:

mkdir -p $RPM_BUILD_ROOT%{_sbindir}/
install -pm0755 build/apt-cacher-ng $RPM_BUILD_ROOT%{_sbindir}/

3. For manpages:

cp   doc/man/*.8 $RPM_BUILD_ROOT%{_mandir}/man8/

-->

install -pm0644 doc/man/*.8 $RPM_BUILD_ROOT%{_mandir}/man8/

4. %changelog
* Fri Mar 14 2014 Kenjiro Nakayama <knakayam@xxxxxx.com> - 0.7.11-3
- update spec file.

You didn't bump the changelog, please fix.

Comment 7 Kenjiro Nakayama 2014-03-14 00:57:33 UTC
(In reply to Christopher Meng from comment #6)

Thanks again.

I updated.

Updated Spec URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng.spec
Updated SRPM URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng-0.7.25-3.fc20.src.rpm
koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6631416

> 1. Sources should not contain any local server name like .de, you can replace it with .jp, it still works ;)

Updated.

> 2. 
> In order to ensure that the permissions are set correctly, for binaries you should use install with -m option:

Updated.

> 3. For manpages:

Updated.

> 4. %changelog
> You didn't bump the changelog, please fix.

Sorry! Updated.

Comment 8 Christopher Meng 2014-03-14 03:18:30 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



Issues:
=======
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "zlib/libpng", "Unknown or generated", "*No copyright* Public domain". 70
     files have unknown license. Detailed output of licensecheck:

*No copyright* Public domain
----------------------------
apt-cacher-ng-0.7.25/include/sha1.h
apt-cacher-ng-0.7.25/source/sha1.cc

Unknown or generated
--------------------
apt-cacher-ng-0.7.25/client/client.cc
apt-cacher-ng-0.7.25/dbgen/checkdebmirrors.sh
apt-cacher-ng-0.7.25/dbgen/deburlgen.pl
apt-cacher-ng-0.7.25/dbgen/gentoo_mirrors.sh
apt-cacher-ng-0.7.25/dbgen/ubuntuscan.sh
apt-cacher-ng-0.7.25/deprecated/checkenv.sh
apt-cacher-ng-0.7.25/deprecated/debsplit.pl
apt-cacher-ng-0.7.25/distkill.pl
apt-cacher-ng-0.7.25/expire-caller.pl
apt-cacher-ng-0.7.25/fs/httpfs.cc
apt-cacher-ng-0.7.25/include/acbuf.h
apt-cacher-ng-0.7.25/include/acfg.h
apt-cacher-ng-0.7.25/include/aclogger.h
apt-cacher-ng-0.7.25/include/bgtask.h
apt-cacher-ng-0.7.25/include/cacheman.h
apt-cacher-ng-0.7.25/include/caddrinfo.h
apt-cacher-ng-0.7.25/include/cleaner.h
apt-cacher-ng-0.7.25/include/config.h
apt-cacher-ng-0.7.25/include/conn.h
apt-cacher-ng-0.7.25/include/conserver.h
apt-cacher-ng-0.7.25/include/csmapping.h
apt-cacher-ng-0.7.25/include/debug.h
apt-cacher-ng-0.7.25/include/dirwalk.h
apt-cacher-ng-0.7.25/include/dlcon.h
apt-cacher-ng-0.7.25/include/expiration.h
apt-cacher-ng-0.7.25/include/fileio.h
apt-cacher-ng-0.7.25/include/fileitem.h
apt-cacher-ng-0.7.25/include/filereader.h
apt-cacher-ng-0.7.25/include/header.h
apt-cacher-ng-0.7.25/include/job.h
apt-cacher-ng-0.7.25/include/lockable.h
apt-cacher-ng-0.7.25/include/maintenance.h
apt-cacher-ng-0.7.25/include/meta.h
apt-cacher-ng-0.7.25/include/mirror.h
apt-cacher-ng-0.7.25/include/pkgimport.h
apt-cacher-ng-0.7.25/include/rfc2553emu.h
apt-cacher-ng-0.7.25/include/showinfo.h
apt-cacher-ng-0.7.25/include/sockio.h
apt-cacher-ng-0.7.25/include/tcpconnect.h
apt-cacher-ng-0.7.25/include/testdlopen.h
apt-cacher-ng-0.7.25/include/testpthread.h
apt-cacher-ng-0.7.25/include/testssl.h
apt-cacher-ng-0.7.25/source/acbuf.cc
apt-cacher-ng-0.7.25/source/acfg.cc
apt-cacher-ng-0.7.25/source/acfg_defaults.cc
apt-cacher-ng-0.7.25/source/aclogger.cc
apt-cacher-ng-0.7.25/source/apt-cacher.cc
apt-cacher-ng-0.7.25/source/bgtask.cc
apt-cacher-ng-0.7.25/source/cacheman.cc
apt-cacher-ng-0.7.25/source/caddrinfo.cc
apt-cacher-ng-0.7.25/source/cleaner.cc
apt-cacher-ng-0.7.25/source/conn.cc
apt-cacher-ng-0.7.25/source/conserver.cc
apt-cacher-ng-0.7.25/source/dirwalk.cc
apt-cacher-ng-0.7.25/source/dlcon.cc
apt-cacher-ng-0.7.25/source/expiration.cc
apt-cacher-ng-0.7.25/source/fileio.cc
apt-cacher-ng-0.7.25/source/fileitem.cc
apt-cacher-ng-0.7.25/source/filereader.cc
apt-cacher-ng-0.7.25/source/header.cc
apt-cacher-ng-0.7.25/source/job.cc
apt-cacher-ng-0.7.25/source/lockable.cc
apt-cacher-ng-0.7.25/source/maintenance.cc
apt-cacher-ng-0.7.25/source/meta.cc
apt-cacher-ng-0.7.25/source/mirror.cc
apt-cacher-ng-0.7.25/source/pkgimport.cc
apt-cacher-ng-0.7.25/source/rfc2553emu.cc
apt-cacher-ng-0.7.25/source/showinfo.cc
apt-cacher-ng-0.7.25/source/tcpconnect.cc
apt-cacher-ng-0.7.25/urlencode-fixer.pl

zlib/libpng
-----------
apt-cacher-ng-0.7.25/include/md5.h
apt-cacher-ng-0.7.25/source/md5.cc

[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[!]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[!]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 81920 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Perl:
[?]: Package contains the mandatory BuildRequires and Requires:.
     Note: Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo
     $version)) missing?

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Files in /run, var/run and /var/lock uses tmpfiles.d when appropriate
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: apt-cacher-ng-0.7.25-3.fc21.i686.rpm
          apt-cacher-ng-0.7.25-3.fc21.src.rpm
apt-cacher-ng.i686: E: description-line-too-long C A caching proxy. Specialized for package files from Linux distributors, primarily for Debian (and Debian based) distributions.
apt-cacher-ng.i686: W: only-non-binary-in-usr-lib
apt-cacher-ng.i686: W: non-standard-uid /var/run/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: W: non-standard-gid /var/run/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: E: non-standard-dir-perm /var/run/apt-cacher-ng 0700L
apt-cacher-ng.i686: W: non-standard-uid /var/lib/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: W: non-standard-gid /var/lib/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: E: non-standard-dir-perm /var/lib/apt-cacher-ng 0700L
apt-cacher-ng.i686: W: non-standard-uid /var/cache/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: W: non-standard-gid /var/cache/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: E: non-standard-dir-perm /var/cache/apt-cacher-ng 0700L
apt-cacher-ng.i686: W: non-standard-uid /var/log/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: W: non-standard-gid /var/log/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: E: non-standard-dir-perm /var/log/apt-cacher-ng 0700L
apt-cacher-ng.i686: E: non-readable /etc/cron.daily/apt-cacher-ng 0750L
apt-cacher-ng.i686: E: non-standard-executable-perm /etc/cron.daily/apt-cacher-ng 0750L
apt-cacher-ng.i686: E: executable-marked-as-config-file /etc/cron.daily/apt-cacher-ng
apt-cacher-ng.i686: W: dangling-relative-symlink /etc/apt-cacher-ng/backends_ubuntu.default ../../var/lib/apt-cacher-ng/backends_ubuntu.default
apt-cacher-ng.i686: W: dangling-relative-symlink /etc/apt-cacher-ng/backends_debian.default ../../var/lib/apt-cacher-ng/backends_debian.default
apt-cacher-ng.i686: E: non-executable-script /usr/libexec/apt-cacher-ng/expire-caller.pl 0644L /usr/bin/perl
apt-cacher-ng.src: E: description-line-too-long C A caching proxy. Specialized for package files from Linux distributors, primarily for Debian (and Debian based) distributions.
apt-cacher-ng.src:73: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 73)
2 packages and 0 specfiles checked; 10 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint apt-cacher-ng
apt-cacher-ng.i686: E: description-line-too-long C A caching proxy. Specialized for package files from Linux distributors, primarily for Debian (and Debian based) distributions.
apt-cacher-ng.i686: W: only-non-binary-in-usr-lib
apt-cacher-ng.i686: W: non-standard-uid /var/run/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: W: non-standard-gid /var/run/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: E: non-standard-dir-perm /var/run/apt-cacher-ng 0700L
apt-cacher-ng.i686: W: non-standard-uid /var/lib/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: W: non-standard-gid /var/lib/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: E: non-standard-dir-perm /var/lib/apt-cacher-ng 0700L
apt-cacher-ng.i686: W: non-standard-uid /var/cache/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: W: non-standard-gid /var/cache/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: E: non-standard-dir-perm /var/cache/apt-cacher-ng 0700L
apt-cacher-ng.i686: W: non-standard-uid /var/log/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: W: non-standard-gid /var/log/apt-cacher-ng apt-cacher-ng
apt-cacher-ng.i686: E: non-standard-dir-perm /var/log/apt-cacher-ng 0700L
apt-cacher-ng.i686: E: non-readable /etc/cron.daily/apt-cacher-ng 0750L
apt-cacher-ng.i686: E: non-standard-executable-perm /etc/cron.daily/apt-cacher-ng 0750L
apt-cacher-ng.i686: E: executable-marked-as-config-file /etc/cron.daily/apt-cacher-ng
apt-cacher-ng.i686: W: dangling-relative-symlink /etc/apt-cacher-ng/backends_ubuntu.default ../../var/lib/apt-cacher-ng/backends_ubuntu.default
apt-cacher-ng.i686: W: dangling-relative-symlink /etc/apt-cacher-ng/backends_debian.default ../../var/lib/apt-cacher-ng/backends_debian.default
apt-cacher-ng.i686: E: non-executable-script /usr/libexec/apt-cacher-ng/expire-caller.pl 0644L /usr/bin/perl
1 packages and 0 specfiles checked; 9 errors, 11 warnings.
# echo 'rpmlint-done:'



Requires
--------
apt-cacher-ng (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/perl
    config(apt-cacher-ng)
    crontabs
    libbz2.so.1
    libc.so.6
    libdl.so.2
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    liblzma.so.5
    liblzma.so.5(XZ_5.0)
    libpthread.so.0
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    libwrap.so.0
    libz.so.1
    logrotate
    perl(MIME::Base64)
    perl(Socket)
    perl(Sys::Hostname)
    perl(strict)
    rtld(GNU_HASH)
    systemd



Provides
--------
apt-cacher-ng:
    apt-cacher-ng
    apt-cacher-ng(x86-32)
    config(apt-cacher-ng)



Source checksums
----------------
http://ftp.debian.org/debian/pool/main/a/apt-cacher-ng/apt-cacher-ng_0.7.25.orig.tar.xz :
  CHECKSUM(SHA256) this package     : 736c65bc28123567a79b661267270aac0cfb579efff4daebfddc9b0764e3b432
  CHECKSUM(SHA256) upstream package : 736c65bc28123567a79b661267270aac0cfb579efff4daebfddc9b0764e3b432
http://ftp.debian.org/debian/pool/main/a/apt-cacher-ng/apt-cacher-ng_0.7.25-1.debian.tar.xz :
  CHECKSUM(SHA256) this package     : 6b5e0e35410ed2770e395b35d9dffedbb53e31e58fc0666ef95055c09e3b7168
  CHECKSUM(SHA256) upstream package : 6b5e0e35410ed2770e395b35d9dffedbb53e31e58fc0666ef95055c09e3b7168


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -rvn apt-cacher-ng-0.7.25-3.fc20.src.rpm
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, Perl
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

--------------------------------------
1. [!]: %build honors applicable compiler flags or justifies otherwise.

Building issues:

i.   -- Performing Test HAVE_SSL
     -- Performing Test HAVE_SSL - Failed
     OpenSSL not found or not working, disabling support

Missing BuildRequires openssl-devel

ii.  -- Performing Test HAVE_BOOST_SMARTPTR
     -- Performing Test HAVE_BOOST_SMARTPTR - Failed

Quoted from INSTALL:

" - GCC and Boost headers (http://boost.org)
   OR GCC 4.x and its libstdc++ with header files
   OR a GCC compatible compiler and STL with C++-0x compliant smart pointers"

You should add BR boost-devel.

iii.  cd build && cmake .. "-DCMAKE_CXX_FLAGS=-g -O3 -Wall"

You can use "%cmake" to configure before building instead of "make %{?_smp_mflags}" directly, as the cxxflags and ldflags are not set properly.

From the gmake file shipped in xz, you can see

ifneq ($(DEBUG),)
	 CXXFLAGS += -g -O0 -DDEBUG
	 CMAKEOPTS += -DADDDEBUGSRC=1 --debug-trycompile --debug-output
endif

ifneq ($(CXXFLAGS),)
CMAKEOPTS += "-DCMAKE_CXX_FLAGS=$(CXXFLAGS)"
else
CMAKEOPTS += "-DCMAKE_CXX_FLAGS=-g -O3 -Wall"
endif

ifneq ($(LDFLAGS),)
CMAKEOPTS += "-DCMAKE_EXE_LINKER_FLAGS=$(LDFLAGS)"
endif

Thus solutions:

1) make CXXFLAGS=%{optflags} LDFLAGS=%{__global_ldflags} %{?_smp_mflags}

2) mkdir build && cd build && %cmake ..
   make %{?_smp_mflags}

2. Quoted from INSTALL again:

" - for apt clients, there is a config snipped in contrib/10-apt-cacher-ng.conf
   which might be installed into /etc/apt/apt.conf.d/."

Have you tested it if it works as expected on Fedora?

3. This package contains a folder named systemd/, it includes sysconfig and systemd unit, you should use the one shipped in the tarball instead of using a patch. And you've forgotten the sysconfig file.

4. [!]: Package contains no bundled libraries without FPC exception.

   apt-cacher-ng-0.7.25/include/sha1.h
   apt-cacher-ng-0.7.25/source/sha1.cc

copylib I think, but not granted exception in:

https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries

like md5:

https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries#cite_note-0

So I think you need to file an fpc ticket.

5. zlib/libpng
   -----------
   apt-cacher-ng-0.7.25/include/md5.h
   apt-cacher-ng-0.7.25/source/md5.cc

Maybe this is a C++ port of Peter Deutsch's version, you need to add

Provides: bundled(md5-deutsch-c++)

But please double check by yourself.

6. apt-cacher-ng.i686: E: description-line-too-long C A caching proxy. Specialized for package files from Linux distributors, primarily for Debian (and Debian based) distributions.

Remember 79 chars per line in %description.

7. apt-cacher-ng.i686: E: non-standard-executable-perm /etc/cron.daily/apt-cacher-ng 0750L
apt-cacher-ng.i686: E: executable-marked-as-config-file /etc/cron.daily/apt-cacher-ng

chmod -x, I think a configuration file doesn't need that.

8. apt-cacher-ng.i686: W: dangling-relative-symlink /etc/apt-cacher-ng/backends_ubuntu.default ../../var/lib/apt-cacher-ng/backends_ubuntu.default
apt-cacher-ng.i686: W: dangling-relative-symlink /etc/apt-cacher-ng/backends_debian.default ../../var/lib/apt-cacher-ng/backends_debian.default

You can ignore this, but please ensure they are correct ;)

9. apt-cacher-ng.i686: E: non-executable-script /usr/libexec/apt-cacher-ng/expire-caller.pl 0644L /usr/bin/perl

Not 755?

10. 
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

You must give a choice ;)

Comment 9 Kenjiro Nakayama 2014-03-14 12:52:51 UTC
(In reply to Christopher Meng from comment #8)

Hi, thank you for your great review.

I updated. But some pending things, please check #3 and #7

Updated Spec URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng.spec
Updated SRPM URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng-0.7.25-3.fc20.src.rpm
koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6632491

~~~~~~~~~~~~~~~

> 1. [!]: %build honors applicable compiler flags or justifies otherwise.

Updated like following.

i)   -> Added BR: openssl-devel
ii)  -> Added BR: boost-devel.
iii) -> mkdir build && cd build && %cmake ..
        make %{?_smp_mflags}

> 2. Quoted from INSTALL again:
>  
> " - for apt clients, there is a config snipped in contrib/10-apt-cacher-ng.conf
>    which might be installed into /etc/apt/apt.conf.d/."
>  
> Have you tested it if it works as expected on Fedora?

Yes, I have already been using apt-cacher-ng.
This quote is for client configuration.
As all fedora users use apt-cacher-ng as only cache server, we don't need client configuration on Fedora.

> 3. This package contains a folder named systemd/, it includes sysconfig and systemd unit, you should use the one shipped in the tarball instead of using a patch. And you've forgotten the sysconfig file.

I updated to include *.service file instead of using a patch.

> it includes sysconfig and systemd unit

Hmm... do you mean the sysconfig is /etc/systemd/system/*.service ?
If so, I think it is not necessary to include package, it should be copied by user.
If it means *.target, *.target is not necessary for apt-cacher-ng.
Sorry if I misunderstand, and I could not find appropriate packaging guideline.
I checked man 5 systemd.unit.

> 4. [!]: Package contains no bundled libraries without FPC exception.
>  
>    apt-cacher-ng-0.7.25/include/sha1.h
>    apt-cacher-ng-0.7.25/source/sha1.cc
>  
> copylib I think, but not granted exception in:
>  
> https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries
>  
> like md5:
>  
> https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries#cite_note-0
>  
> So I think you need to file an fpc ticket.

OK, I will file an fpc ticket soon.

> 5. zlib/libpng
>
> Maybe this is a C++ port of Peter Deutsch's version, you need to add
>  
> Provides: bundled(md5-deutsch-c++)

Updated.

> 6. apt-cacher-ng.i686: E: description-line-too-long C A caching proxy. Specialized for package files from Linux distributors, primarily for Debian (and Debian based) distributions.

Updated to less than 79 chars.

> 7. apt-cacher-ng.i686: E: non-standard-executable-perm /etc/cron.daily/apt-cacher-ng 0750L
> apt-cacher-ng.i686: E: executable-marked-as-config-file /etc/cron.daily/apt-cacher-ng
>  
> chmod -x, I think a configuration file doesn't need that.

Pending.
I thought a file which is placed in /etc/cron.daily/ need to be executable. Is chmod -x really necessary?

> 8. apt-cacher-ng.i686: W: dangling-relative-symlink /etc/apt-cacher-ng/backends_ubuntu.default ../../var/lib/apt-cacher-ng/backends_ubuntu.default
> apt-cacher-ng.i686: W: dangling-relative-symlink /etc/apt-cacher-ng/backends_debian.default ../../var/lib/apt-cacher-ng/backends_debian.default
>  
> You can ignore this, but please ensure they are correct ;)

OK, I see.

> 9. apt-cacher-ng.i686: E: non-executable-script /usr/libexec/apt-cacher-ng/expire-caller.pl 0644L /usr/bin/perl
>  
> Not 755?

Updated, yes it should be 0755.
(updated)-> install -pm 0755 build/in.acng expire-caller.pl urlencode-fixer.pl distkill.pl $RPM_BUILD_ROOT%{_libexecdir}/apt-cacher-ng/

> 10. 
> - Package uses either %{buildroot} or $RPM_BUILD_ROOT
>   Note: Using both %{buildroot} and $RPM_BUILD_ROOT
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

Updated, use $RPM_BUILD_ROOT :D

Comment 10 Kenjiro Nakayama 2014-03-17 05:26:21 UTC
(In reply to Kenjiro Nakayama from comment #9)

> OK, I will file an fpc ticket soon.

I submitted fpc ticket. [1]

[1] https://fedorahosted.org/fpc/ticket/407

Comment 11 Kenjiro Nakayama 2014-03-25 13:07:46 UTC
(In reply to Kenjiro Nakayama from comment #10)

I got an advice about my ticket. [1]
It seems that I should use SHA1 which is included in OpenSSl or some other packages.

Altough I will keep waiting for the FPC's comment, I try to use and test SHA1 which is included in Open SSL.

[1] https://lists.fedoraproject.org/pipermail/packaging/2014-March/010106.html

Comment 12 Kenjiro Nakayama 2014-03-26 10:57:15 UTC
I updated.

Updated Spec URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng.spec
Updated SRPM URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng-0.7.25-3.fc20.src.rpm
koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6674928

> 4. [!]: Package contains no bundled libraries without FPC exception.

I have not got any reply from FPC yet[1], but I have no doubt that I should not include SHA library in my package.[2][3]
I decided to use openssl's SHA library.

[1] https://fedorahosted.org/fpc/ticket/407
[2] https://lists.fedoraproject.org/pipermail/packaging/2014-March/010108.html
[3] https://lists.fedoraproject.org/pipermail/packaging/2014-March/010106.html

Comment 13 Kenjiro Nakayama 2014-03-27 23:33:39 UTC
I updated.

> 4. [!]: Package contains no bundled libraries without FPC exception.
>
> I have not got any reply from FPC yet[1], but I have no doubt that I should not include SHA library in my package.[2][3]
> I decided to use openssl's SHA library.

Sorry, Fedora FPC allows bundling of this sha1 implementation. So I added Provides: bundled(sha1-hollerbach) and not using openssl's sha1 library.

[1] https://fedorahosted.org/fpc/ticket/407

Updated Spec URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng.spec
Updated SRPM URL: http://diy-kenjiro.rhcloud.com/rpms/apt-cacher-ng-0.7.25-3.fc20.src.rpm
koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6680985

Comment 14 Christopher Meng 2014-03-28 01:46:12 UTC
(In reply to Kenjiro Nakayama from comment #13)
> I updated.

Heheh, as I can see you've changed at least 2 times...

Calm down, please wait for the final FPC decision.

Thanks.

Comment 15 Kenjiro Nakayama 2014-03-28 05:57:18 UTC
(In reply to Christopher Meng from comment #14)

> Calm down, please wait for the final FPC decision.

Yes, sorry... I wait for the final FPC.

Comment 16 Kenjiro Nakayama 2014-03-31 13:21:34 UTC
Got five votes [1].

[1] https://fedorahosted.org/fpc/ticket/407

Comment 17 Christopher Meng 2014-04-16 05:54:30 UTC
Good news to see FPC has accepted the bundling exception.

PACKAGE APPROVED.

Comment 18 Kenjiro Nakayama 2014-04-16 23:39:19 UTC
> PACKAGE APPROVED.

Thank you so much!

New Package SCM Request
=======================
Package Name: apt-cacher-ng
Short Description: Caching proxy for package files.
Owners: kenjiro
Branches: f20
InitialCC:

Comment 19 Jens Petersen 2014-04-17 05:08:53 UTC
Git done (by process-git-requests).

Comment 20 Fedora Update System 2014-04-17 08:38:28 UTC
apt-cacher-ng-0.7.25-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/apt-cacher-ng-0.7.25-3.fc20

Comment 21 Fedora Update System 2014-04-18 15:42:15 UTC
apt-cacher-ng-0.7.25-3.fc20 has been pushed to the Fedora 20 testing repository.

Comment 22 Fedora Update System 2014-05-01 22:28:05 UTC
apt-cacher-ng-0.7.25-3.fc20 has been pushed to the Fedora 20 stable repository.


Note You need to log in before you can comment on or make changes to this bug.